//+------------------------------------------------------------------+
//|                                         Heiken Ashi Smoothed.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 RoyalBlue
#property indicator_color3 Red
#property indicator_color4 RoyalBlue
#property indicator_width3 3
#property indicator_width4 3

//
//
//
//
//

extern int MaMetod   = 2;
extern int MaPeriod  = 6;
extern int MaMetod2  = 3;
extern int MaPeriod2 = 2;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(8);
   SetIndexBuffer(0,ExtMapBuffer1);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ExtMapBuffer4);SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexBuffer(7,ExtMapBuffer8);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)   
   {
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN ,i);
      double maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,i);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW  ,i);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH ,i);

      double haOpen  = (ExtMapBuffer5[i+1]+ExtMapBuffer6[i+1])/2;
      double haClose = (maOpen+maHigh+maLow+maClose)/4;
      double haHigh  = MathMax(maHigh, MathMax(haOpen, haClose));
      double haLow   = MathMin(maLow, MathMin(haOpen, haClose));

      //
      //
      //
      //
      //
      
      ExtMapBuffer7[i]=haClose;  
      ExtMapBuffer8[i]=haClose;
      if (haOpen<haClose) 
            { ExtMapBuffer7[i]=haLow;  ExtMapBuffer8[i]=haHigh; } 
      else  { ExtMapBuffer7[i]=haHigh; ExtMapBuffer8[i]=haLow;  }
              ExtMapBuffer5[i]=haOpen;
              ExtMapBuffer6[i]=haClose;
   }
   for(i=limit; i>=0; i--)
   {
      ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer7,0,MaPeriod2,0,MaMetod2,i);
      ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer8,0,MaPeriod2,0,MaMetod2,i);
      ExtMapBuffer3[i]=iMAOnArray(ExtMapBuffer5,0,MaPeriod2,0,MaMetod2,i);
      ExtMapBuffer4[i]=iMAOnArray(ExtMapBuffer6,0,MaPeriod2,0,MaMetod2,i);
   }      
   return(0);
}

